//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}


int main()
{
  vector<int> coll1;
  list<int> coll2;

  INSERT_ELEMENTS(coll1,1,9);
  PRINT_ELEMENTS(coll1,"1- :\n");

  //     coll1
  transform (coll1.begin(), coll1.end(),      // 
             coll1.begin(),                   // 
             negate<int>());                  // 
  PRINT_ELEMENTS(coll1," :\n");

  //   coll1,   10,  coll2
  transform (coll1.begin(), coll1.end(),      // 
             back_inserter(coll2),            // 
             bind2nd(multiplies<int>(),10));  // 
  PRINT_ELEMENTS(coll2,"2-  (  10):\n");

  //   coll2       
  cout << ToRus("2-  (      ):\n");
  transform (coll2.rbegin(), coll2.rend(),    // 
             ostream_iterator<int>(cout," "), // 
             negate<int>());                  // 
  cout << endl;


  getch();
  return 0;
}

//---------------------------------------------------------------------------